HDU 5469 Antonidas

Antonidas

Time Limit: 4000ms

Memory Limit: 65536KB

This problem will be judged on HDU. Original ID: 5469
64-bit integer IO format: %I64d      Java class name: Main

Given a tree with N vertices and N−1 edges. Each vertex has a single letter Ci. Given a string S, you are to choose two vertices A and B, and make sure the letters catenated on the shortest path from A to B is exactly S. Now, would you mind telling me whether the path exists?

Input
The first line is an integer T, the number of test cases.
For each case, the first line is an integer N. Following N−1 lines contains two integers a and b, meaning there is an edge connect vertex a and vertex b.
Next line contains a string C, the length of C is exactly N. String C represents the letter on each vertex.
Next line contains a string S.
$1\leq T\leq 200, 1\leq N\leq 10^4, 1\leq a,b\leq N, a\not = b, |C|=N, 1\leq |S|\leq 10^4$. String C and S both only contain lower case letters.

Output
First, please output "Case #k: ", k is the number of test case. See sample output for more detail.
If the path exists, please output “Find”. Otherwise, please output “Impossible”.

Sample Input

2

7
1 2
2 3
2 4
1 5
5 6
6 7
abcdefg
dbaefg

5
1 2
2 3
2 4
4 5
abcxy
yxbac

Sample Output

Case #1: Find
Case #2: Impossible

Source

2015 ACM/ICPC Asia Regional Shanghai Online

解题:点分治+hash

debug大半天的成果啊

比如一个目标串是$abcdefg$,假设我们树分治的时候,选的根恰好是$d$,那么我们需要的怎样的hash信息?是不是从$d->a$以及$d->g$的hash信息啊,注意方向。d才是高位!!!

所以我们要预处理出来目标串每个字符么,向左走到端点已经向右走到端点的hash值。

在树分治的时候,我们可以从根到当前点,走出一条路,路上的点就会hash出一个值,根据深度,我们可以看看它跟这个长度的前缀配不配,或者跟这个长度的后缀配不配,配的话,我们要分别找剩下长度的后缀或者前缀是否存在。

比放说根就是$d$,当前走到深度4,那么我们就可以看看目标串从4位置hash到 1位置的hash跟当前路径的hash值等否?如果相等,那么需要一段什么样的值呢?

需要一个后缀,从d开始,走到g这段的hash值,是否在前面的搜索过程中出现过,如果出现过,那么好了a到d的有了,d到g的也有了,那么a到g的就有了,答案就找到了。

  1 #include <bits/stdc++.h>
  2 using namespace std;
  3 using ULL = unsigned long long;
  4 const int maxn = 10010;
  5 const ULL Base = 31;
  6 struct arc{
  7     int to,next;
  8     arc(int x = 0,int y = -1){
  9         to = x;
 10         next = y;
 11     }
 12 }e[maxn<<1];
 13 bool vis[maxn];
 14 int head[maxn],sz[maxn],maxson[maxn],pre[maxn],suf[maxn],tot,len,cnt;
 15 ULL Pre[maxn],Suf[maxn],B[maxn] = {1};
 16 char sa[maxn],sb[maxn];
 17 void add(int u,int v){
 18     e[tot] = arc(v,head[u]);
 19     head[u] = tot++;
 20 }
 21 void dfs(int u,int fa){
 22     sz[u] = 1;
 23     maxson[u] = 0;
 24     for(int i = head[u]; ~i; i = e[i].next){
 25         if(e[i].to == fa || vis[e[i].to]) continue;
 26         dfs(e[i].to,u);
 27         sz[u] += sz[e[i].to];
 28         maxson[u] = max(maxson[u],sz[e[i].to]);
 29     }
 30 }
 31 int FindRoot(int sum,int u,int fa){
 32     int ret = u;
 33     maxson[u] = max(maxson[u],sum - sz[u]);
 34     for(int i = head[u]; ~i; i = e[i].next){
 35         if(e[i].to == fa || vis[e[i].to]) continue;
 36         int x = FindRoot(sum,e[i].to,u);
 37         if(maxson[x] < maxson[ret]) ret = x;
 38     }
 39     return ret;
 40 }
 41 bool cao(int u,ULL w,int fa,int depth,bool op) {
 42     if(depth > len) return false;
 43     w = w*Base + (ULL)sa[u];
 44     if(op) {
 45         if(w == Pre[depth] && suf[depth] == cnt) return true;
 46         if(w == Suf[len - depth + 1] && pre[len - depth + 1] == cnt) return true;
 47     } else {
 48         if(w == Pre[depth]) pre[depth] = cnt;
 49         if(w == Suf[len - depth + 1]) suf[len - depth + 1] = cnt;
 50     }
 51     for(int i = head[u]; ~i; i = e[i].next) {
 52         if(vis[e[i].to] || e[i].to == fa) continue;
 53         if(cao(e[i].to,w,u,depth + 1,op)) return true;
 54     }
 55     return false;
 56 }
 57 bool solve(int u){
 58     dfs(u,0);
 59     if(sz[u] < len) return false;
 60     int root = FindRoot(sz[u],u,0);
 61     vis[root] = true;
 62     ++cnt;
 63     ULL w = sa[root];
 64     if(w == Pre[len]) return true;
 65     if(w == Pre[1]) pre[1] = cnt;
 66     if(w == Suf[len]) suf[len] = cnt;
 67     for(int i = head[root]; ~i; i = e[i].next){
 68         if(vis[e[i].to]) continue;
 69         if(cao(e[i].to,w,root,2,true)) return true;
 70         cao(e[i].to,w,root,2,false);
 71     }
 72     for(int i = head[root]; ~i; i = e[i].next){
 73         if(vis[e[i].to]) continue;
 74         if(solve(e[i].to)) return  true;
 75     }
 76     return false;
 77 }
 78 int main(){
 79     int kase,n,u,v,cs = 1;
 80     for(int i = 1; i < maxn; ++i) B[i] = B[i-1]*Base;
 81     scanf("%d",&kase);
 82     while(kase--){
 83         scanf("%d",&n);
 84         memset(head,-1,sizeof head);
 85         memset(vis,false,sizeof vis);
 86         memset(pre,0,sizeof pre);
 87         memset(suf,0,sizeof suf);
 88         tot = 0;
 89         for(int i = 1; i < n; ++i){
 90             scanf("%d%d",&u,&v);
 91             add(u,v);
 92             add(v,u);
 93         }
 94         scanf("%s%s",sa + 1,sb + 1);
 95         len = strlen(sb + 1);
 96         for(int i = 1; i <= len; ++i) Pre[i] = Pre[i-1] + B[i-1]*sb[i];
 97         Suf[len + 1] = 0;
 98         for(int i = len; i > 0; --i) Suf[i] = Suf[i+1] + B[len - i]*sb[i];
 99         printf("Case #%d: %s\n",cs++,solve(1)?"Find":"Impossible");
100     }
101     return 0;
102 }

时间: 2024-11-03 20:51:25

HDU 5469 Antonidas的相关文章

【搜索剪枝】HDU 5469 Antonidas

通道 题意:给出1字母树,询问一字符串是否出现在该树中 思路:直接搜索剪枝,有人点分治?写了几发都T了..有人会了教我? 代码: #include <cstdio> #include <cstring> #include <algorithm> using namespace std; struct Edge { int v, nxt; Edge () { } Edge (int _v, int _n) { v = _v, nxt = _n; } }; const in

HDU 5469 Antonidas (树形DP,暴力)

题意: 给一棵n节点的树图,每个点都是一个小写字母,要求找到两个点(a,b),从a->b的路径上形成了一个字符串为s.给出s,问是否存在这样的点对. 思路: 考虑一个点,要么从该点出发,要么在该点结束,要么它作为一个中间点将左右两个串连起来成为s.叶子只能是起点或者终点.在每个点中需要保存两个队列,表示有点可以从正or反向走到这个点的长度(即前缀与后缀,但只需记录当前点是排在第几).对于在本节点连接的情况,枚举一下哪些孩子可能在本节点连接就行了. 2s多 1 #include <bits/st

补题列表

上海网络赛: HDU 5468 Puzzled Elena HDU 5469 Antonidas HDU 5473 There was a kingdom 合肥网络赛: HDU 5487 Difference of Languages HDU 5486 Difference of Clustering HDU 5489 Removed Interval HDU 5492 Find a path HDU 5493 Queue 弱校联萌Day1: B. Carries D. Vertex Cover

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是

HDU 5917 Instability ramsey定理

http://acm.hdu.edu.cn/showproblem.php?pid=5917 即世界上任意6个人中,总有3个人相互认识,或互相皆不认识. 所以子集 >= 6的一定是合法的. 然后总的子集数目是2^n,减去不合法的,暴力枚举即可. 选了1个肯定不合法,2个也是,3个的话C(n, 3)枚举判断,C(n, 4), C(n, 5) #include <bits/stdc++.h> #define IOS ios::sync_with_stdio(false) using name